\documentclass[conference]{IEEEtran}

\usepackage{balance}
\usepackage{graphicx,multirow,booktabs,caption, array, listings}
\usepackage{url}
\usepackage{listings}
\usepackage{textcomp}
\usepackage{gensymb}
\usepackage{float}
\usepackage{caption} 
\usepackage{subcaption}
\usepackage{comment}
\usepackage{array}
\usepackage{listings}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{multicol}
\usepackage{amsmath}
\usepackage{color, colortbl}
\usepackage{siunitx}
\def\BibTeX{{\rm B\kern-.05em{\sc i\kern-.025em b}\kern-.08em
		T\kern-.1667em\lower.7ex\hbox{E}\kern-.125emX}}
\begin{document}

\title{CP-Trie: Cumulative PopCount based Trie for IPv6 Routing Table Lookup in Software and ASIC}

\author{\IEEEauthorblockN{MD Iftakharul Islam, Javed I Khan}
	\IEEEauthorblockA{\textit{Kent State University}\\
		Kent, Ohio, USA \\
		mislam4@kent.edu, javed@cs.kent.edu}
}

\IEEEoverridecommandlockouts
\IEEEpubid{\makebox[\columnwidth]{978-1-6654-4005-9/21/\$31.00~\copyright{}2021 IEEE
		\hfill} \hspace{\columnsep}\makebox[\columnwidth]{ }}

\maketitle

\begin{abstract}
Routing table lookup is a key function of a router. It involves performing the longest prefix match (LPM) of an IP address. Poptrie, the state-of-the-art trie based routing table lookup, encodes nodes using population counting bitmap. Poptrie uses PopCount CPU instruction which can process only $64$ bits at a time. This is why, Poptrie uses $6$-bit stride ($2^6 = 64$). This paper presents an extension of Poptrie named CP-Trie (stands for Cumulative PopCount based Trie) where it stores cumulative PopCount along with population counting bitmap. This enables CP-Trie to process longer stride (e.g. $8-16$ bits) at each step. This reduces the number of steps and the number of memory access needed for an IP lookup. The fewer number of steps results in faster lookup. It also results in less power consumption in ASIC. Fewer memory accesses indicate that it requires fewer SRAM blocks in ASIC which results in lower area. This is why, CP-Trie is a more practical solution for pipelined ASIC compared to Poptrie. Our experiments with routing tables from real core routers show that CP-Trie achieves upto $1.43 \times$ lookup throughput on a general purpose CPU, but consumes $1.36-1.47 \times$ memory compared to Poptrie. We also implemented Poptrie and CP-Trie in a $1$ GHz pipelined ASIC. Our physical synthesis report shows that CP-Trie consumes $0.86 \times$ power and $0.79 \times$ area compared to Poptrie in ASIC.

\end{abstract}

\begin{IEEEkeywords}
	IPv6 routing table lookup; LPM; Core Router; Pipelined ASIC
\end{IEEEkeywords}

\section{Introduction}\label{sec:intro}
A router needs to perform routing table lookup for each incoming packet. Here, the router performs the longest prefix match of the destination IP address. For instance, Table \ref{lpm} shows an example routing table of a router. If the destination IP address an incoming packet is 200a:410:8088:500::300, it matches with both $r2$ and $r3$. As $r3$ has longer prefix than $r2$, the packet should be forwarded to next-hop $3$. Again, if the destination IP address is 200a:410:8000:702::0de, it matches with $r2$ and $r4$. As $r4$ has longer prefix, the packet should be forwarded to next-hop $1$. 

IPv6 routing table lookup in core routers faces several challenges. Firstly, the number of IPv6 routes in core router already has exceeded $100$K and growing very rapidly. \footnote{http://bgp.potaroo.net/} Secondly, routing table lookup needs to achieve very high throughput. For instance, a $4.8$ Tb/s Brodcom Jericho2 chip (used in many core routers) can forward $2,000$ million packets per second (Mpps) \cite{CiscoNCS5500, attcorerouter}. Finally, an IPv6 lookup may need to match upto $128$ bits while IPv4 may need to match upto $32$ bits. Thus, IPv6 lookup may require $4 \times$ processing and significantly more memory compared to IPv4 lookup. 

\begin {table}[H]
\caption {Example IPv6 routing table} \label{lpm} 
\begin{center}
	\begin{tabular}{ | m{1cm}| m{4.4cm} | m{1.3cm} |} 
		\hline Route & Prefix & Next-hop\\
		\hline r1 & $200a:4:112::/48$ & $1$\\
		\hline r2 & $200a:410:8000::/40$ & $2$\\
		\hline r3 & $200a:410:8080::/44$ & $3$\\
		\hline r4 & $200a:410:8000:702::/64$ & $1$\\		
		\hline r5 & $200a:410:8000:702::0df/128$ & $2$\\						
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

Routing table lookup implementations fall into several categories: software (general purpose CPU), GPU, FPGA, TCAM and pipelined ASIC based solutions. In this paper, we focus on software and pipelined ASIC based IPv6 lookup. Note that, we use the terms "routing table lookup", "IP lookup", and "Forwarding Information Base (FIB) lookup" interchangeably. IP lookup algorithms in software and ASIC mainly fall into two categories: trie \cite{asai2015poptrie, yang2014guarantee, eatherton2004tree, degermark1997small, song2005shape, huang2011offset, nilsson1999ip, baboescu2005tree, basu2003fast, jiang2008beyond, kumar2006camp, hasan2005dynamic, islam2019sail} and hash \cite{pong2011concise, pong2009suse, bando2010flashtrie, broder2001using, hasan2006chisel, bando2009flashlook, song2009ipv6, song2009scalable} based solutions. This paper mainly focuses on trie based solutions. A trie based IP lookup algorithm should achieve following design goals:
\begin{itemize}
\item \textbf{Fewer number of steps}: The fewer number of steps results in faster lookup. It also reduces the power consumption in ASIC. 

\item \textbf{Fewer memory accesses:} Fewer memory accesses is very critical in pipelined ASIC. In pipelined ASIC, each pipeline stage has to access SRAM in parallel. Thus, a pipelined ASIC requires separate SRAM blocks which can serve the pipeline stages simultaneously. \footnote{It is also possible to implement pipelined ASIC using a multiport SRAM. However, developing a multiport SRAM requires designing custom SRAM cell based on the required number of ports \cite{ataei2017high, nichols2019automated}. Increasing the number of ports increases the area and power consumption of the SRAM significantly. This is why, most of the real-world pipelined ASICs use separate SRAM blocks instead of a multiport SRAM \cite{pong2009suse, pong2011concise}.} It also has been found that fewer large SRAM blocks are more area efficient than many smaller SRAM blocks \cite{pong2009suse, pong2011concise}.\footnote{This is because control logics, address decoders and sense amplifiers of SRAM consume around $85\%$ of the SRAM area \cite{pong2011concise}.} This is why, reducing the number of memory access reduces the number of SRAM blocks needed in ASIC which results in smaller area.

\item \textbf{Small memory consumption and fast incremental update:} An IP lookup algorithm should consume small memory and fast incremental update.

\end{itemize}

This paper presents an IPv6 routing table lookup algorithm named CP-Trie which is an extension of Poptrie \cite{asai2015poptrie}. Poptrie divides an IPv6 routing table table into 20 levels: level $16$, $22$, $28$, $34$, $40$, $46$, $52$, $58$, $64$, $70$, $76$, $82$, $88$, $94$, $100$, $106$, $112$, $118$, $124$ and $130$ ($6$-bit stride). \footnote{We use direct indexing for level $16$\cite{asai2015poptrie}} It uses $6$-bit stride because the PopCount CPU instruction it uses can process only $64$ bits on a $64$-bit machine $(2^6 = 64)$. This paper presents an extension of Poptrie named CP-Trie where we store cumulative PopCount along with the population counting bitmaps. Using cumulative PopCount enables CP-Trie to use longer stride ($8$ or $16$ bits in this case) while using PopCount instruction only once at each step. CP-Trie splits an IPv6 routing table into $15$ levels: level $16$, $24$, $32$, $40$, $48$, $56$, $64$, $72$, $80$, $88$, $96$, $104$, $112$, $120$ and $128$. As a result, CP-Trie needs fewer number of steps. This results in faster lookup and low power consumption in ASIC. The fewer number of steps also reduces the number of memory access. As a result, CP-Trie will require fewer SRAM blocks compared to Poptrie which results in lower area.
		
\begin{comment}	
	\item Named Data Networking (NDN) uses longest prefix match on the names \cite{zhang2014named, song2015scalable}. The names in NDN can be significantly longer than IPv6 prefix. This is why, CP-Trie is a more practical solution for NDN prefix match compared to Poptrie. This is however out of the scope of this paper.
\end{comment}



This paper also describes the implementation of CP-Trie and Poptrie \cite{asai2015poptrie} in software and ASIC. We evaluated our software implementation with routing tables from real core router \cite{routeviews}. On the other hand, we evaluated our ASIC implementation (Verilog RTL) using OpenROAD \cite{ajayi2019toward} electronic design automation (EDA) tool. We made our software and ASIC implementation publicly available (https://tamimcse.github.io/cp-trie).

\begin{comment}

Finally, we also evaluate our algorithms for Xilinx Zynq-7000 FPGA. Our experiemental results show that SAIL and CP-Trie perform $1.38 \times$ and $1.17 \times$ faster lookup respectively compared to Poptrie.  

\end{comment}


The remaining of the paper proceeds as follows.  Section \ref{sec:related_works} presents the related works. Section \ref{sec:proposed_approaches} illustrates the general idea behind CP-Trie by showing a simpler example. Section \ref{sec:algorithm} describes the routing table lookup algorithm. Section \ref{sec:implementation} discusses our implementation. Section \ref{sec:eval_asic} shows the evaluation of ASIC. Section \ref{experimental_results} shows the experimental results. Section \ref{discussion} discusses future works based on CP-Trie. Finally, Section \ref{conclusion} concludes the paper.

\begin{figure*}[!t]
	\begin{subfigure}[t]{0.39\textwidth}
		\centering
		\includegraphics[width=7cm]{treewopush}
		\caption{Routing table and the corresponding binary tree}\label{treewopush}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.36\textwidth}
		\centering
		\includegraphics[width=6.5cm]{tree}
		\caption{Level pushing to level $3$ and level $6$}\label{binarytree}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{.3\textwidth}
		\centering
		\includegraphics[width=5.5cm]{array}
		\caption{Bitmap corresponding to level $3$ and $6$}\label{array}
	\end{subfigure}%	
	
	\caption{CP-Trie data structure}\label{tree}
\end{figure*}

\section{Related Works}\label{sec:related_works}
Routing table lookup is a very long standing research problem. This section discusses the existing IPv4 and IPv6 longest prefix match algorithms and their implementations. Existing  solutions fall into following categories: TCAM, trie, hash, direct lookup and range search based solutions. Trie based IP lookup is the main focus of this paper.


\textbf{TCAM based IP lookup:} TCAM is widely used in midrange routers with limited number of prefixes \cite{mcauley1993fast, zane2003coolcams, zheng2006tcam, ravikumar2004tcam}. However, TCAM is very expensive, area-inefficient and power hungry. It also requires very complex incremental update. This is why, it is not suitable for core routers \cite{jiang2008beyond, bando2010flashtrie, pong2011concise}.

   
\textbf{Hash based IP lookup:} Hash based solutions have widely been used for IP lookups. Waldvogel et. al. \cite{waldvogel1997scalable} first presented a mechanism where IP prefixes are divided among multiple hash tables based on the prefix length. It then performs exact match in the hash tables in different order. Later, several hashing mechanism have been proposed to improve hash based IP lookup. Those include d-left hashing \cite{broder2001using}, Chisel \cite{hasan2006chisel}, FlashLook \cite{bando2009flashlook}, FlashTrie \cite{bando2010flashtrie}, IPStash \cite{kaxiras2005ipstash}, DLB-BF \cite{song2009ipv6}, Progressive hashing \cite{hanna2009progressive}, Shape graph \cite{song2009scalable}, SUSE \cite{pong2009suse}, CoLT \cite{pong2011concise}, PIHT \cite{yu2009hash}, BFHT \cite{song2005fast}, SHIP \cite{stimpfling2019ship} and so on. Several researches also used bloom filter to select the hash tables in order to reduce the number of hash table lookups \cite{hasan2006chisel, song2009ipv6, dharmapurikar2003longest, liu2019longest}. Hash table based approach offers very high throughput and low latency because multiple hash tables can be looked up in parallel. They also offer superior incremental update. SUSE and CoLT have been adopted in Brodcom routing SoC. Hash based IP lookups however suffer from high memory consumption. They also require many hash function calculation and many simultaneous hash table access.


\textbf{Direct IP lookup:} DIR-24-8 \cite{gupta1998routing} is a direct lookup mechanism where smaller prefixes can be looked up directly with just $1$ memory access. However, this approach requires very large memory. It is also not suitable for longer prefixes. DIR-24-8 is currently being used for IP lookup in DPDK \footnote{https://www.dpdk.org/}. 


\textbf{Range search based IP lookup:} DXR \cite{zec2012dxr} represents a routing table with an array of address ranges. It then performs a binary search in the array during the lookup. Here, the binary search is the primary bottleneck. BRTree \cite{yang2013architecture} used a balanced range tree to implement IP lookup in FPGA.

\textbf{Trie based IP lookup:} Trie based solutions are very attractive for solving longest prefix match problem and focus of this paper. They are particularly attractive due to small memory consumption. LC-trie \cite{nilsson1999ip} combines path and level compression in a trie to reduce memory consumption. It however exhibits poor the cache behavior resulting slow lookup speed \cite{fu2006performance}. LC-trie has been adopted in Linux kernel. R\'etv\'ari et al. \cite{retvari2013compressing} proposed a trie compression algorithm that can compress a FIB with $440$K routes with just $100$-$400$ KB. However, small FIB table does not always result good lookup performance. For instance, their IPv4 FIB lookup consumes $194$ CPU cycles. SAIL \cite{yang2014guarantee} proposed a trie splitting approach where a routing table is split into multiple levels. It encodes each level with array. Although SAIL shows impressive lookup performance, it consumes very large memory. Islam et al. \cite{islam2019sail} observed that most of the array elements of SAIL remain zero in practice. They used bitmaps to  keep track of non-empty elements. This approach eliminates all the empty elements which reduces the memory consumption of SAIL by up to $80\%$. They also implemented their solution inside Linux kernel and Domino \cite{sivaraman2016packet} switch compiler. Lule\aa $\ $ \cite{degermark1997small} encodes a leaf-pushing tree \cite{srinivasan1998faster} with bitmaps. This scheme reduces the memory consumption significantly. However, the incremental update in this approach can be very expensive because a prefix which smaller length can be pushed to upper levels. Tree Bitmap \cite{eatherton2004tree} improves the update performance of Lule\aa $\ $ by limiting the number of levels a node can be pushed. These scheme however increases the memory consumption moderately compared to Lule\aa $\ $ algorithm. TreeBitmap has been adopted by Cisco routers. Shape-Shifting Trie \cite{song2005shape} is a variant of Tree Bitmap where it encodes a Trie using \textit{shape bitmap} and compact tree \cite{jacobson1989space}. This reduces the memory consumption of Tree Bitmap by approximately $50\%$ for sparse tries. FlashTrie \cite{bando2010flashtrie} combines hashing and prefix-compressed trie (PC-trie) which reduces the memory consumption significantly. Offset Encoded Trie (OET) \cite{huang2011offset} encodes each trie node with a next-hop bitmap and an offset value to reduce memory consumption. Poptrie \cite{asai2015poptrie} has been proposed which reduces the memory consumption significantly while exhibiting impressive lookup performance. The main shortcoming of Poptrie is that it uses $6$ bit stride. This paper presents CP-Trie where it uses $16$-bit stride for the first level and $8$-bit stride for the following levels. This reduces the number of steps and the number of memory access needed for a routing table lookup. 

Several researches have described specialized hardwares for implementing Trie based IP lookup algorithms. LEAP \cite{harris2012leap} and PLUG \cite{de2009plug} proposed programmable hardwares which are specialized for implementing various IP lookup and packet classification algorithms. SWSL \cite{kim2013swsl} and C2RTL \cite{tamimc2rtl} proposed high-level synthesis tools which can generate ASIC (Verilog RTL) directly from an IP lookup algorithm implemented in C/C++.  Several proposals \cite{baboescu2005tree, basu2003fast, jiang2008beyond, kumar2006camp, hasan2005dynamic} proposed different Trie splitting approaches for ASIC so that all the SRAM modules have uniform amount of memory. This is done in order to avoid bottleneck among the pipeline stages. In this paper, we implemented CP-Trie and Poptrie in pipelined ASIC using C2RTL \cite{tamimc2rtl}.

\begin{figure}[!t]
	\centering
	\includegraphics[width=5cm]{lookup}
	\caption{Index calculation for the next level ($B6$) and $Leaf$}\label{lookup}
\end{figure}

\section{Proposed Approach}\label{sec:proposed_approaches}
Figure \ref{tree} illustrates CP-Trie with a simple example. Figure \ref{treewopush} shows an example routing table and the corresponding binary tree. Here, the nodes with a next-hop are called solid nodes and the rest of the nodes are called internal nodes. For the sake of simplicity, here we split the tree into two levels: level $3$ and $6$. That is, we process $3$ bits in each step (i.e. stride size is $3$). Here, we also assume that PopCount instruction can process only $4$ bits at a time. That is, the PopCount instruction cannot process the whole stride ($2^3$ bits) at a time. CP-Trie pushes the nodes to level $3$ and $6$ as in Figure \ref{binarytree}. The level pushing is done as following: all the nodes (both solid and internal) in level $1$ and $2$ are pushed to level $3$. If the original tree has an internal node in level $3$, those nodes and the nodes in level $4$ and $5$ are pushed to level $6$. For instance, node B is pushed to both level $3$ and level $6$. CP-Trie then encodes level $3$ and $6$ with bitmaps as in Figure \ref{array}. Here the $i$-th bit in $B3$ indicates if the $i$-th node in level $3$ is a solid node or not. Again, the $i$-th bit in $C3$ indicates if the $i$-th node in level $3$ is a leaf or not. Here the leaf nodes are represented by the $0$ bits and the non-leaf nodes are represented by the $1$ bits. Again, $B6$ is constructed based on the solid nodes in level $6$. This is how, we construct $B3$, $C3$ and $B6$ in Figure \ref{array}. As our PopCount can process only $4$ bits a time, we group every $4$ bits and add a cumulative PopCount in each group (Figure \ref{array}). Cumulative PopCount contains the number of $1$ bit prior to that group. This enables us to compute the total number of $1$ bits in the whole stride by applying PopCount only on a part of the stride (this will be discussed more later in this section). Finally, CP-Trie creates a $leaf$ array that contains all the solid nodes in level $3$ followed by solid nodes in level $6$. Note that the cumulative population count of $B6$ does not start from zero. It rather starts from $3$ (the total number of $1$ bit in level $3$). This is because we maintain a single array to store  the solid nodes from all the levels. This is why, level $6$ needs to start from where the level $3$ has ended. 

\textbf{Lookup approach:} Let us assume that we want to lookup an IP address $111110b$ in the routing table. The lookup process is illustrated in Figure \ref{lookup}. The lookup process proceeds as follows. It extracts three leftmost bits from the IP address. Let us call it $x$. Here, $x = 7$. We calculate the index to $C3$ as $\frac{x}{4}$. As $\frac{7}{4} = 1$, $C3[1]$ is the corresponding element to the IP address. Note that all the division operations in this paper are integer divisions. Again we calculate the bit spot inside $C3[1]$ as $x \% 4 + 1$.  Here, the bit-spot is $4$. That is, the $4$-th bit of $C3[1]$ corresponds to the IP address. As the bit is $1$, it indicates that a longer prefix exists, thus we need to lookup in level $6$. We calculate the index to $B6$ as shown in the Figure \ref{lookup}. We calculate PopCount of the bits to the left of the spot-bit (the result is $0$ in this case) and add that to the cumulative population count ($1$ in this case). Thus the sum is $1$. The number indicates the number of $1$s to the left of the spot bit upto $C3[0]$. The number also indicates the number of non-leaf nodes to the left of the current node (in level $3$ in Figure \ref{binarytree}). We then multiply the number by $2$. This is because each stride is $3$ bits and we group every $4$ bits, thus each stride consists of $2$ array elements ($\frac{2^3}{4}$). We then add it to $\frac{x}{4}$ where $x$ is the right-most three bits ($6$ in this case) from the IP address. Thus the index to $B6$ is $3$ ($[popcnt (000) + 1] * 2 + \frac{6}{4}$). We also calculate the spot bit inside $B6[3]$ as $x \% 4 + 1 = 3$. Thus, the third bit of $B6[3]$ corresponds to the IP address. As the bit is $1$, it indicates that the longest prefix match is found. We then calculate the index to $Leaf$ as $popcnt(11) + 8 = 10$. Thus the next-hop would be found in $Leaf[10]$ ($B$ in this case).

Note that CP-Trie needs to use just one PopCount instruction at each step even though the stride size is $3$. More over, if we use longer stride, this approach will still need just one PopCount at each step. In real implementation, we use $16$-bit stride for the first level and $8$-bit stride for the following levels. We use PopCount instruction that can process only $64$ bits. Using cumulative population count saves us from using multiple PopCount instructions for $8$ or $16$ bit stride. Note that, although it is possible to implement $256$-bit PopCount or $65536$-bit PopCount in ASIC (for $8$ ort $16$ bit stride respectively), their area and power consumption would be substantially higher than that of a $64$-bit PopCount \cite{ciccardi2019intelligent}.


\textbf{CP-Trie data structure:} Although we have illustrated CP-Trie with a simpler example, in actual implementation, CP-Trie divides a routing table into 15 levels: level $16$, $24$, $32$, $40$, $48$, $56$, $64$, $72$, $80$, $88$, $96$, $104$, $112$, $120$ and $128$. Thus, each level contains a $B$ and $C$ array except the level $128$ which only contains a $B$ array. Each element of $B$ and $C$ array contains a $64$-bit \textit{bitmap} and $32$-bit cumulative population count (we refer to as \textit{cumu\_popcnt}).


\begin{algorithm*}
	\caption{CP-Trie based routing table lookup algorithm. The function $extract(ip, \ off, \ len)$ extracts a bit array of
		 length $len$ from the IP address $ip$, starting from the offset $off$. The function $popcnt\_lft(x, \ n)$ counts the number of $1$-bit in left-most $n$ bits of bitmap $x$.}\label{algocptrie} 
	\begin{flushleft}	
		\textbf{Input}: Destination IP address of the packet - $ip$ \\
		\textbf{Output}: Next-hop - $nexthop$
	\end{flushleft}
	\begin{algorithmic}[1]				
		\Procedure{Lookup}{$ip$}
		\State $mask \gets 0X8000000000000000ULL$
		\State $stride \gets extract(ip, \ 0, \ 16)$
		\State $idx \gets stride \  / \ 64$
		\State $bitspot \gets stride \  \% \ 64$
		\State $curr\_level \gets level16$
		\State $offset \gets 16$
		\While {$curr\_level.C[idx].bitmap \ \& \ (mask \ >> \ bitspot)$}		
		\State $stride \gets extract(ip, \ offset, \ 8)$
		\State $idx \gets (curr\_level.C[idx].cumu\_popcnt \ + \ popcnt\_lft (curr\_level.C[idx].bitmap, \ bitspot)) \ * \ 4 \ + \ stride \ / \ 64 $
		\State $bitspot \gets stride \  \% \ 64$
		\State $offset \gets offset \ + \ 8$
		\State $curr\_level \gets curr\_level.next$
		\EndWhile
		\If {$curr\_level.B[idx].bitmap \ \& \ (mask \ >> \ bitspot)$}	
		\State $idx \gets curr\_level.B[idx].cumu\_popcnt \ + \ popcnt\_lft (curr\_level.B[idx].bitmap, \ bitspot)$
		\State {return $Leaf[idx]$}		
		\EndIf
		\State {return $default\_nexthop$}\hfill\Comment{//return default next-hop if no match is found} 
		\EndProcedure		
	\end{algorithmic}
\end{algorithm*}

\section{Lookup Algorithm}\label{sec:algorithm}
Algorithm \ref{algocptrie} shows the lookup process of CP-Trie. It starts by extracting $16$ leftmost bits from the IP address (Line $3$). CP-Trie calculates the index to $C16$ by diving the \textit{stride} by $64$ (Line $4$). As we group every $64$ bits to create a bitmap, the index to both $B$ and $C$ array is calculated by diving by $64$ (in the similar fashion as in the example where we calculate it as $\frac{x}{4}$). Line $5$ calculates the bit spot inside the bitmap by taking modulo operation by $64$ (whereas in the example, we calculate as $x \ \% \ 4 + 1$). Line $6$ initializes the current level to level $16$. Line $8$ checks if the matching node in the current level is a non-leaf; if yes, it visits the next level in Line $9-13$ (will be discussed later). On the other hand, if the matching node in the current level is a leaf, Line $8$ will exist the loop. Line $14$ then checks if there is a matching prefix for the IP in $B$ array of the current level, if yes, Line $15$ calculates the index to $Leaf$ array in the same fashion as shown in Figure \ref{lookup}. Line $16$ returns the next-hop. On the other hand, if Line $14$ does not find a matching prefix, it indicates that there is no matching prefix for the IP address. It returns the default next-hop in that case (Line $17$).

Line $9-13$ illustrates how CP-Trie visits each level in order. It first extracts next $8$ bits from the IP (Line $9$). Line $10$ calculates the index to the next level in the same fashion as shown in Figure \ref{lookup}. One difference however is we multiply the sum of cumulative population count and $popcnt\_lft()$ by $4$. This is because, as the stride size is $8$, each stride consists of $4$ array elements ($\frac{2^8}{64}$). Line $11$ calculates the spot bit based on the current stride. Line $13$ updates the current level to next level. Note that, the next level of level $16$ is level $24$. Again, the next level of level $24$ is level $32$. This is how, we visit level $16$, $24$, $32$, $40$, $48$, $56$, $64$, $72$, $80$, $88$, $96$, $104$, $112$, $120$ and $128$ in order. Note that, CP-Trie does not need to backtrack to a lower level in order to find the longest match. For instance, if the longest prefix match for an IP address is in level $48$, CP-Trie will visit $C16$, $C24$, $C32$, $C40$, $C48$ and $B48$.

\begin{comment}

\begin{lstlisting}[language=C, caption=CP-Trie based routing table lookup, float=*, label={ppcalgo}]
#define MSK 0b1000000000000000000000000000000000000000000000000000000000000000
//Calculates the number of 1s in left-most S bits of B
#define POPCNT_LFT (B, S) popcount(B >> (64 - S))

uint8_t routing_table_lookup(__uint128_t ip){
1.  uint32_t stride = ip >> 112;//Extract 16 leftmost bits from IP
2.  uint32_t idx = stride / 64;//Calculate index to C16
3.  uint32_t spot = stride % 64;//spot-th bit in the bitmap corresponds the IP 
4.    
5.  if (C16[idx].bitmap & (MSK >> spot)) { //Check if the matching node is a non-leaf
6.      stride = (ip >> 104) & 0XFF;//Extract next 8 bits
7.      //Calculate actual index to C24
8.      idx = (C16[idx].cumu_popcnt + POPCNT_LFT(C16[idx].bitmap, spot)) * 4 + stride/64;
9.      spot = stride % 64;
10.     if (C24[idx].bitmap & (MSK >> spot)) { //Check if the matching node is a non-leaf
11.         stride = (ip >> 96) & 0XFF;//Extract next 8 bits
12.         idx = (C24[idx].cumu_popcnt + POPCNT_LFT(C24[idx].bitmap, spot)) * 4 + stride/64;
13.         spot = stride % 64;
14.         if (C32[idx].bitmap & (MSK >> spot)) {
15.             stride = (ip >> 88) & 0XFF;//Extract next 8 bits
16.             idx = (C32[idx].cumu_popcnt + POPCNT_LFT(C32[idx].bitmap, spot)) * 4 + stride/64;
17.             spot = stride % 64;
18.             //visit level 40,48,56,64,72,80,88,96,104,112,120,128 in the similar fashion
19.         } else if (B32[idx].bitmap & (MSK >> spot))
20.             return Leaf[B32[idx].cumu_popcnt + POPCNT_LFT(B32[idx].bitmap, spot)];
21.     } else if (B24[idx].bitmap & (MSK >> spot))
22.         return Leaf[B24[idx].cumu_popcnt + POPCNT_LFT(B24[idx].bitmap, spot)];
23. } else if (B16[idx].bitmap & (MSK >> spot))
24.     return Leaf[B16[idx].cumu_popcnt + POPCNT_LFT(B16[idx].bitmap, spot)];
25. return 0;//no-match found
}
\end{lstlisting}


\section{Lookup Algorithm}
Listing \ref{ppcalgo} shows the lookup process of CP-Trie. It starts by extracting $16$ leftmost bits from the IP address (Line $1$). Let us call it \textit{stride}. CP-Trie calculates the index to $C16$ by diving the \textit{stride} by $64$ (Line $2$). As we group every $64$ bits to create a bitmap, the index to both $B$ and $C$ array is calculated by diving by $64$ (in the similar fashion as in the example where we calculate it as $\frac{x}{4}$). Line $3$ calculates the bit spot inside the bitmap by taking modulo operation by $64$ (whereas in the example, we calculate as $x \ \% \ 4 + 1$). Line $5$ checks if the matching node in level $16$ is a non-leaf; if yes, it visits the next level, level $24$ in Line $6-10$. Line $6$ extracts next $8$ bits ($17-24$ bit) from the IP address. Line $8$ calculates the index to $C24$ in the same fashion as shown in Figure \ref{lookup}. One difference however is we multiply the sum of cumulative population count and $POPCNT\_LFT()$ by $4$. This is because, as the stride size is $8$, each stride consists of $4$ array elements ($\frac{2^8}{64}$). Line $9$ calculates the spot bit for the bitmap in level $24$. Line $10$ then checks if the matching node in level $24$ is a non-leaf; if yes, it visits level $32$ (Line $11-14$). This is how, CP-Trie checks if the matching  node in the level in a non-leaf; if yes, it moves to the next level. On the other hand, if it finds that the matching node is a leaf, it indicates that the longest prefix would be found in the current level. It then checks the $B$ array to calculate the index to the $Leaf$ array. For instance, if Line $5$ finds that the matching node in level $16$ is a leaf, it jumps to line $23$. Line $23$ then checks if there is a matching prefix for the IP in $B16$, if yes, Line $24$ calculates the index to $Leaf$ array in the same fashion as shown in Figure \ref{lookup}. In the same way, if Line $10$ is false, it jumps to line $21$ and checks if there is a matching prefix in level $24$, if yes, it calculates the index to $Leaf$ array in the similar fashion (Line $22$). Note that CP-Trie does not need to backtrack to a lower level in order to find the longest match. For instance, if the longest prefix match for an IP address is in level $48$, CP-Trie will visit $C16$, $C24$, $C32$, $C40$, $C48$ and $B48$. 

\end{comment}

\section{Implementation}\label{sec:implementation}
This section discusses the software and ASIC implementation of CP-Trie and Poptrie. Our software and ASIC implementation will be found in Github (https://tamimcse.github.io/cp-trie). This experiment has been conducted on a machine that has an Intel(R) Core (TM) i7-4510U processor and 16 GB DRAM. The processor has $2$ cores with $4$ threads running at up to $3.1$ GHz (maximum frequency). The processor has $32$ KB L1 data cache, $32$ KB L1 instruction cache, $256$ KB L2 cache and $4$ MB L-$3$ cache.

\subsection{Software Implementation} 
We implemented Poptrie, CP-Trie and SAIL (both SAIL\_U and SAIL\_L)\cite{yang2014guarantee} based FIB lookup and FIB update. Our implementation contains around $3,000$ lined of C code. Here, we used the results of SAIL\_U to perform unit testing of our implementation of Poptrie and CP-Trie. We choose SAIL\_U as the basis of our testing because of its simpler implementation. However, as the performance of SAIL is significantly different from that of Poptrie and CP-Trie, we do not compare SAIL in this paper. In this paper, we use CPU performance counter (TSC register) to measure the performance. \footnote{https://en.wikipedia.org/wiki/Time\_Stamp\_Counter}

\begin{comment}

\begin{figure}[!t]
	\centering
	\includegraphics[width=5cm]{hls-flow}
	\caption{ASIC development flow}\label{hls-flow}
\end{figure}



\begin{figure}[!t]
	\begin{subfigure}[t]{2.8cm}
		\centering
		\includegraphics[width=2.7cm]{poptrie-gds}
		\caption{Poptrie}\label{poptrie-gds}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{2.8cm}
		\centering
		\includegraphics[width=2.7cm]{cptrie-gds}
		\caption{CP-Trie}\label{cptrie-gds}
	\end{subfigure}%	
	
	\caption{Chip layout (GDSII) of the Poptrie and CP-Trie }\label{gds}
\end{figure}

\end{comment}

\subsection{ASIC Implementation}
We used C2RTL \cite{tamimc2rtl} high-level synthesis (HLS) tool to generate synthesizable Verilog implementations of CP-Trie and Poptrie. C2RTL takes a C implementation of an algorithm as an input and generates corresponding Verilog RTL code. We performed the functional verification of the generated Verilog code of Poptrie and CP-Trie using Icarus Verilog\footnote{http://iverilog.icarus.com/}.

\begin {table}[H]
\caption {Power, area and timing in ASIC (for logic)} \label{powerconsumption_openroad} 
\begin{center}
	\begin{tabular}{ | m{2.5cm}| m{2cm}| m{2cm} |}
		\hline  & Poptrie & CP-Trie\\
		\hline Clock speed & $1$ GHz & $1$ GHz \\
		\hline Internal Power & $76.5$ mW& $64.6$ mW\\
		\hline Switching Power & $24.4$ mW & $22.2$ mW\\
		\hline Leakage Power & $1.15$ mW& $0.926$ mW\\
		\hline Total Power & $102.05$ mW & $87.726$ mW\\
		\hline Area & $0.0658$ $mm^2$ & $0.0523$ $mm^2$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\section{Evaluation of ASIC}\label{sec:eval_asic}
EDA tools enable us to generate physical chip layout directly from Verilog RTL code. Example of EDA tools include OpenROAD \cite{ajayi2019toward}, Synopsis Fusion compiler \cite{icc}, Cadence Innovus \cite{innovus}, and so on. They take Verilog RTL code, macros (e.g. SRAM, I/O ports, etc), a cell library and constraints (e.g. clock cycle) as inputs and generates corresponding physical chip layout in GDSII format. Here, we use OpenROAD \cite{ajayi2019toward} to generate physical chip layout of Poptrie and CP-Trie. We pass following inputs to OpenROAD: 1) an RTL implementation of a FIB lookup algorithm, 2) $1$ GHz clock (clock cycle is $1$ ns) and 3) CMOS $45$ nm Nandgate Open Cell Library. OpenROAD generates GDSII layout from the inputs. Our OpenROAD timing report shows that out implementation of CP-Trie and Poptrie can achieve $1$ GHz without timing violation. That is, our implementation of CP-Trie and Poptrie can perform one lookup in every $1$ ns. Thus, it can perform $1$ billion lookups per second. Note that, currently there is no SRAM available for $45$ nm Nandgate cell library, to the best of our knowledge. This is why, we use registers to implement the arrays. OpenROAD also reports power and area of the ASIC. Table \ref{powerconsumption_openroad} shows the summery of OpenROAD report for Poptrie and CP-Trie.  It shows that CP-Trie consumes less power and less area compared to Poptrie. This is because CP-Trie needs to implement fewer levels than Poptrie. Thus, it will require fewer logic gates in the ASIC.

Our implementation also shows that Poptrie and CP-Trie need $79$ and $59$ arrays respectively. Thus, Poptrie and CP-Trie need $79$ and $59$ SRAM blocks respectively. Note that, fewer large SRAM blocks are more area efficient than more smaller SRAM blocks because control logics, address decoders and sense amplifiers of SRAM consume around $85\%$ area  \cite{pong2009suse, pong2011concise}. This is why, although CP-Trie consumes $1.36-1.47 \times$ memory compared to Poptrie (shown in Section \ref{experimental_results}), we expect SRAM blocks of CP-Trie to consume less area and power consumption than those of Poptrie. Thus, we expect CP-Trie to be even more area and power effcient than reported in Table \ref{powerconsumption_openroad} when SRAM is incorporated.

\begin{comment}

Note that, OpenROAD is only responsible for generating compute module. We also need SRAM arrays on the chip so that compute pipeline can access the SRAM modules in parallel. There are many SRAM IP vendors such as Synopsys, Cadence, ARM and so on \cite{guthaus2016openram}. Those on-chip SRAM IP which can be integrated to our compute pipeline. Here, we do not use a specific SRAM IP. We instead use CACTI-P \cite{li2011cacti} SRAM simulator to calculate the power and area cost of on-chip SRAM needed for Poptrie and CP-Trie.\footnote{We can also use open source memory compiler such as AMC  \cite{ataei2019amc} to generate an on-chip SRAM module. However, currently it uses SCN3ME SUBM $0.5${\textmu}m technology which is very old and requires very high power and area} Let us assume that we want to use a $512$ KB SRAM module for each array of our FIB lookup algorithms so that it can accommodate future FIB expansion. Table \ref{powerconsumption_aladdin} shows the power and area for SRAM module. Here, dynamic power consumption of CP-Trie is smaller than that of Poptrie. This is because, CP-Trie needs to perform fewer memory read operation than Poptrie. For instance, to reach the last level, CP-Trie needs to visit $15$ levels whereas Poptrie needs to visit $20$ levels. Both CP-Trie and Poptrie reads $12$ bytes from SRAM at each level. Thus, Poptrie needs to read more data from SRAM than CP-Trie which increases dynamic power. 



Again, Figure \ref{mem-read} shows the number of bytes read for different prefix lengths. Note that, the number of bytes read by a FIB lookup algorithm depends on the length of the matched prefix. The figure shows that Poptrie needs to read more memory than CP-Trie which results in higher power consumption. CP-Trie needs to read $12$ bytes in each level except for the last level, because each element of $C$ array is $12$ bytes. In the last level, it reads $12 + 12 + 1$ bytes (one $C$ element, one $B$ element and one $Leaf$ element). Poptrie, on the other hand, needs to read $24$ bytes in each level. Poptrie also needs to visit more levels than SAIL and CP-Trie. This is why, Poptrie needs to read more data from memory than SAIL and CP-Trie.

\end{comment}

\begin{comment}
Traditionally, an ASIC is implemented in a Register Transfer Level (RTL) hardware description language such as Verilog, VHDL, SystemVerilog and so on. However, developing synthesizable RTL code (Verilog/VHDL/SystemVerilog) is a huge undertaking \cite{cong2011high}. High-Level Synthesis (HLS) tools enable us to generate synthesizable RTL code from high level language such as C/C++/SystemC. Example of HLS tools include Bambu \cite{pilato2013bambu}, Mentor Catapult \cite{book2010mentor}, Cadence Stratus (formerly C-to-Silicon Compiler \cite{kondratyev2013share} and Forte Cynthesizer \cite{sanguinetti2012transaction}), NEC's CyberWorkBench\cite{wakabayashi2008all}, Synopsys Synphony (formerly PICO-NPA \cite{schreiber2002pico}), Xilinx Vivado (formerly  AutoPilot \cite{cong2011high}) LegUp \cite{canis2011legup}, SWSL \cite{kim2013swsl}, Domino \cite{sivaraman2016packet} and so on. We have generated Varilog implementation of Poptrie and CP-Trie using Bambu \cite{pilato2013bambu}. Bambu takes a C implementation of an algorithm and generates corresponding synthesizable Verilog code. Bambu also simulates the Verilog codes with Verilator \cite{veriloator} to verify that the verilog outputs were consistent with our software models. 


 
\textbf{ASIC synthesis}: Our verilog implementation of the lookup algorithms contain both logic and memory elements. Each array of FIB lookup algorithms needs be implemented as a separate SRAM modules, so that logic elements can access them in parallel. The logic and memory elements of an ASIC are synthesized separately. We use Electronic Design Automation (EDA) tool and memory compiler to synthesize logic and memory respectively. Electronic Design Automation (EDA) tools enable us to generate physical chip layout from of the logic. Examples of logic synthesis tools include Synopsys ICC \cite{icc}, Cadence Innovus \cite{innovus}, OpenROAD \cite{ajayi2019toward} and so on. Here we use OpenROAD to generate physical chip layout of the logic elements. We use CMOS $45$ nm Nandgate Open Cell Library for our logic synthesis. Example of memory compiler include OpenRAM \cite{guthaus2016openram}, AMC \cite{ataei2019amc}, Dolphin's memory compiler \cite{dolphin-memorycompiler}, Artisan Components (acquired by ARM), Virage Logic (acquired by Synopsys) and so on. Here we use AMC \cite{ataei2019amc} to generate the SRAM modules. We use SCN3ME SUBM  $0.5${\textmu}m technology library for SRAM synthesis. The chip layout of each SRAM module will be found in the original paper \cite{ataei2019amc}. Currently, AMC can generate up to $1$MB SRAM module which is comparable to that of commercial memory compilers. As each array of Poptrie and CP-Trie are smaller than $1$ MB, the SRAM modules are sufficient for Poptrie and CP-Trie. Note that, the chip area of a SRAM module at SCN3ME SUBM $0.5${\textmu}m technology is  abnormally large. For instance, a $1$MB SRAM module at SCN3ME SUBM $0.5${\textmu}m technology requires $252.78 \ mm^2$. AMC also can synthesize $65$nm technology library. However, we do not have access to the foundry provided library. This is why, we use Aladdin \cite{shao2014aladdin} for characterizing the area and power consumption of SRAM modules (instead of AMC). Also note that, Alladin internally uses CACTI-P \cite{li2011cacti} SRAM simulator.

\end{comment} 


\begin{comment}

\begin {table}[H]
\caption {OpenROAD synthesis summery} \label{powerconsumption_openroad} 
\begin{center}
	\begin{tabular}{ | m{2.5cm}| m{2cm}| m{2cm} |}
		\hline  & Poptrie & CP-Trie\\
		\hline Clock speed & $400$ MHz & $454$ MHz \\
		\hline Internal Power & $29.5$ mW& $23.3$ mW\\
		\hline Switching Power & $15.8$ mW & $13.2$ mW\\
		\hline Leakage Power & $2.66$ mW& $2.23$ mW\\
		\hline Total Power & $48.00$ mW & $38.8$ mW\\
		\hline Area & $0.687995$ $mm^2$ & $0.687995$ $mm^2$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\end{comment}

\begin{comment}

  \begin {table}[t]
\caption {Power consumption in ASIC (mW)} \label{powerconsumption_openroad} 
\begin{center}
	\begin{tabular}{c|c|c|}
		\hline
		\multicolumn{1}{|c|}{Algorithm} & Poptrie & CP-Trie \\
		\hline
		\multicolumn{1}{|c|}{Clock speed} & $400$ MHz & $454$ MHz \\
		\hline 
		\multicolumn{1}{|c|}{Internal Power} & $29.5$ & $23.3$ \\
		\hline 
		\multicolumn{1}{|c|}{Switching Power} & $15.8$  & $13.2$ \\
		\hline
		\multicolumn{1}{|c|}{Leakage Power} & $2.66$ & $2.23$ \\
		\hline
		\multicolumn{1}{|c|}{Total Power} & $48.00$  & $38.8$ \\
		\hline
	\end{tabular} 	
\end{center}
\end {table}

\end{comment}
 

\begin{comment}

\textbf{SRAM module generation}: Each array of FIB lookup algorithms needs be implemented as a separate SRAM modules, so that logic elements can access them in parallel. We need a memory compiler to generate the SRAM modules. \footnote{EDA tools such as Synopsys ICC, Cadence Innovus and OpenROAD are only responsible for generating the logic elements, not SRAM modules.} Example of commercial memory compiler vendor include Dolphin Technology \cite{dolphin-memorycompiler}, Artisan Components (acquired by ARM), Virage Logic (acquired by Synopsys) and so on. Example of open source academic memory compilers include OpenRAM \cite{guthaus2016openram} and AMC \cite{ataei2019amc}.   

\end{comment}

\begin{comment}

Our experimental results in Section \ref{memoryconsumption} show that Poptrie and CP-Trie consume upto $3.1$ MB and $4.7$ MB memory respectively. Thus, Poptrie and CP-Trie will need $4$ and $5$ SRAM modules respectively. 

\textbf{SRAM characterization}: The chip area of a SRAM module at SCN3ME SUBM $0.5${\textmu}m technology is  significantly large. For instance, a $1$MB SRAM module at SCN3ME SUBM $0.5${\textmu}m technology requires $252.78 \ mm^2$. A $64 \times 10$ Gb/s switch die is typically $200-400 \ mm^2$\cite{gibb2013design}. Thus, using SCN3ME SUBM $0.5${\textmu}m technology for routing chip is not practical. AMC also can synthesize $65$nm technology library. However, we do not have access to the foundry provided library. This is why, we characterize a $1$ MB SRAM module using CACTI-P \cite{li2011cacti} at $40$ nm technology. We found that the area and the power consumption of a $1$ MB SRAM module at $40$ nm technology are $4.47084 \ mm^2$ and $123.394 \ mW$ respectively. We use these values for experimental results (instead of the values for SCN3ME SUBM $0.5${\textmu}m technology).

\end{comment}

\begin{comment}

\textbf{Discussion on Pipelined ASIC}: The Verilog code generated by Bambu currently does not support pipelining at this moment\footnote{Pipeline support in Bambu is a work in progress}. Thus, our current ASIC implementation cannot process packets at line rate. Implementation of Poptrie and CP-Trie in pipelined ASIC is out of the scope of this paper. However, here we explain how it may change the current implementation. A pipelined ASIC can process incoming packets at line line rate. For instance, a $1$ GHz ASIC with pipelining can process $1$ packet in every $1$ ns (thus the throughput is $1$ billion packets per second). As we do not use pipelining, the clock speed of ASIC has no relationship with the lookup throughput in our case. In a pipelined ASIC, each array should be allocated to a separate SRAM module so that different pipeline stages do not access the same SRAM module at a time. For instance, Poptrie has $22$ arrays ($N16, DIR, B16, B22,$ $B28, B34,..., B118, B124, B130, Leaf$), thus needs $22$ SRAM modules assuming that each array will require at most $1$ MB memory. In the same way, CP-Trie has $30$ arrays ($B16, C16, B24, $ $C24,...,B120, C120, B128, Leaf$), thus needs at $30$ SRAM modules. Note that, the clock frequency of SRAM can be smaller than that of the ASIC. In that case, the SRAM modules may need to be replicated in order to achieve the line rate. This is why, the memory needed for Pipelined ASIC is substantially higher than non-pipelined ASIC. Implementation of Pipelined ASIC is however out of the scope of this paper.

\end{comment}

\begin{comment}

\textbf{FPGA synthesis}: The Verilog code generated for ASIC is also synthesizable for FPGA. Here we use Xilinx Vivado v.2019.2 \cite{vivado} to synthesize the Verilog implementation of SAIL, Poptrie and CP-Trie for Xilinx Zynq-$7000$ series xc7z020-1clg484 FPGA.

\end{comment}


\begin{comment}

\textbf{Pipelined ASIC simulation}: The Verilog code generated by Bambu currently does not support pipelining at this moment. Thus, our current ASIC implementation cannot process packets at line rate. Implementation of Poptrie and CP-Trie in pipelined ASIC is out of the scope of this paper. However, here we evaluate Poptrie and CP-Trie with Aladdin \cite{shao2014aladdin}, a pre-RTL pipelined ASIC simulator. We also use Aladdin for characterizing SRAM modules. Aladdin calculates power and area based on OpenPDK $45$nm cell library and CACTI-P \cite{li2011cacti} SRAM simulator. Here we have selected $1$ GHz clock frequency. Note that, a $1$ GHz ASIC can process $1$ packet in every $1$ ns, thus the throughput is $1$ billion packets per second. Aladdin shows that CP-Trie and Poptrie requires $157$ and $207$ clock cycles respectively. Thus, the latency of CP-Trie and Poptrie are $157$ ns and $207$ ns respectively. Table \ref{area-aladdin} shows the chip area estimates for Poptrie and CP-Trie (estimated by Aladdin). Note that, memory accounts for $99.7\%$ of the total chip area. As CP-Trie requires more memory than Poptrie, it requires slightly larger chip area. Again, Table \ref{powerconsumption} shows the power consumption for Poptrie and CP-Trie (estimated by Aladdin). Note that memory contributes more than $92\%$ of the total power consumption. This is why, although logic of CP-Trie consumes less power than that of Poptrie, the total power consumption of CP-Trie is slightly higher than that of Poptrie.
 
\end{comment} 

\begin{comment}
 
\begin {table}[H]
\caption {Power and area cost of on-chip SRAM} \label{powerconsumption_aladdin} 
\begin{center}
	\begin{tabular}{ | m{2.5cm}| m{2cm}| m{2cm} |}
		\hline  & Poptrie & CP-Trie\\
		\hline Dynamic Power & $1.9186$ mW& $1.668$ mW\\
		\hline Leakage Power & $103.299$ mW& $118.467$ mW\\
		\hline Total Power & $105.217$ mW & $120.135$ mW\\
		\hline Area & $6.81073$ $mm^2$ & $7.81316$ $mm^2$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\end{comment}

\begin{comment}

\begin {table}[H]
\caption {Area estimates in ASIC ($mm^2$)} \label{area-aladdin} 
\begin{center}
	\begin{tabular}{ | m{2cm}| m{1.5cm}| m{1.5cm} |}
		\hline  & Poptrie & CP-Trie\\
		\hline Logic Area & $0.0156588$ & $0.0155502$ \\
		\hline Memory Area & $6.81073$ & $7.81316$\\
		\hline Total Area & $6.82639$  & $7.82871$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin {table}[H]
\caption {Power estimates in ASIC (mW)} \label{powerconsumption} 
\begin{center}
	\begin{tabular}{ | m{3.8cm}| m{1cm}  | m{1.4cm}|}
		\hline  & Poptrie & CP-Trie\\
		\hline Avg. Logic Dynamic Power& $8.19812$ & $6.14745$\\
		\hline Avg. Logic Leakage Power& $0.184721$ & $0.184778$\\
		\hline Avg. Logic Power& $8.38284$  & $6.33222$\\
		\hline Avg. Memory Dynamic Power& $1.9186$  & $1.668$\\
		\hline Avg. Memory Leakage Power& $103.299$  & $118.467$\\
		\hline Avg. Memory Power& $105.217$  & $120.135$\\
		\hline Avg. Power& $113.6$ & $126.468$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\end{comment} 

\begin{comment}

\textbf{Pipelined ASIC simulation}: The Verilog code generated by Bambu currently does not support pipelining at this moment\footnote{Pipeline support in Bambu is a work in progress}. This is why, we also evaluate the routing table lookup algorithms with Aladdin \cite{shao2014aladdin}. Aladdin is an ASIC simulator where data-path is a pipeline. A pipelined ASIC can process incoming packets at line rate. Aladdin works like a HLS tool. It takes a C program as an input and generates power and area characteristics of the ASIC without generating the actual the RTL code or physical layout. It is noteworthy that the performance estimation of Aladdin is not fully accurate. The error rate of the latency, power and area estimates of Aladdin are within $0.9\%$, $4.9\%$ and $6.6\%$ respectively \cite{shao2014aladdin}. We have implemented SAIL, Poptrie and CP-Trie within Aladdin \cite{shao2014aladdin}. The source code will be found in the artifact (Appendix B). Aladdin uses the dynamic trace of a program to measure its performance (latency, power, area). Aladdin calculates power and area based on OpenPDK $45$nm cell library and CACTI-P \cite{li2011cacti} SRAM simulator. Here we have selected $1$ GHz clock frequency. Note that, a $1$ GHz ASIC can process $1$ packet in every $1$ ns (thus the throughput is $1$ billion packets per second). We allocate each level of the routing table lookup algorithm to a separate SRAM module. The size of the SRAM modules are set based on the actual memory consumption of the respective algorithms. We also allocate around $20\%$ extra memory to each level to accommodate future routing table expansions.

We have made trivial changes to the core of Aladdin. For instance, the main-line Aladdin does not have the power and area characteristics of $POPCNT$, $SELECT$, $CMP$ and $GEP$ instruction. Here we have included power and area characteristics of those instructions in Aladdin, because our FIB lookup algorithms use those. We have obtained the power and area characteristics of $POPCNT$ from Ciccardi et al. \cite{ciccardi2019intelligent}. $SELECT$, $CMP$ and $GEP$ instructions are simulated with simpler primitive instructions. For instance, $GEP$ (GetElementPointer) is simulated with one addition and one multiplication. Our implementation of Aladdin will be found in the artifact.

Note that, although the FIB lookup is generally implemented in ASIC, the FIB update is implemented in software \cite{basu2005fast}. When a new route is inserted in a routing table, router control plane (runs on CPU) updates its copy of the FIB data structure first. It then simply updates the on-chip memory of the data plane ASIC \cite{basu2005fast}. This is why, we do not evaluate FIB update in ASIC. We only evaluate FIB lookup in ASIC.

\end{comment}



  
\begin{comment}  

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{prefix-distribution}
	\caption{Histogram of prefix lengths}\label{prefix-distribution}
\end{figure}

\end{comment}

\section{EXPERIMENTAL RESULTS}\label{experimental_results}
This section evaluates the performance of Poptrie and CP-Trie on a general purpose CPU.

\begin {table}[H]
\caption {FIB dataset} \label{fibdataset} 
\begin{center}
	\begin{tabular}{ | m{.8cm}| m{1.5cm} | m{3cm}  |}
		\hline Name & \# of prefixes &Longest prefix length\\
		\hline fib0 & $105,363$ & $48$ \\
		\hline fib1 & $102,126$ & $48$\\
		\hline fib2 & $79,431$ & $64$\\
		\hline fib3 & $103,067$ & $128$\\
		\hline fib4 & $105,957$ & $128$\\
		\hline fib5 & $102,739$ & $64$\\
		\hline fib6 & $104,235$ & $48$\\
		\hline fib7 & $100,899$ & $64$\\
		\hline fib8 & $102,731$ & $128$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\subsection{Data Set}
We obtained the Routing Information Base (RIB) of real backbone routers from Route Views project \cite{routeviews}. The RIB snapshot was taken on January $17$, $2021$ at 3 PM EST.  We convert the RIB into multiple FIBs based on the autonomous system (AS) IDs. We also keep only one next-hop per prefix in the FIBs. Table \ref{fibdataset} shows the details of the FIBs in our data set. Note that, although we performed the experiment on a specific RIB, we found similar results for other RIBs as well.

\begin{comment}

Again, an edge router is likely to have lots of prefixes with length higher than $64$. In this paper, we evaluate FIB lookup algorithms with the FIBs from core routers.

\end{comment}

Note that, it is possible to reduce the size of a FIB further by route aggregation \cite{uzmi2011smalta}. SMALTA \cite{uzmi2011smalta} proposed a route aggregation scheme where prefixes belonging to different subtrees are aggregated without modifying forwarding behavior. However, route aggregation does not affect routing table lookup algorithms. Route aggregation can be applied on a FIB without changing the lookup algorithm. Here we do not use \textit{route aggregation} in this experiment. 
 
\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{memory}
	\caption{Memory consumption for different FIBs}\label{memorycomp}
\end{figure}

\begin{figure*}[!t]
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{lookup-throughput-prefix}
		\caption{Prefix traffic}\label{lookup-throughput-prefix}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{lookup-throughput-repeated}
		\caption{Repeated traffic (analogous to real Internet trace)}\label{lookup-throughput-repeated}
	\end{subfigure}%
	
	\begin{subfigure}[t]{.5\textwidth}
		\centering
		\includegraphics[width=9cm]{lookup-throughput-sequential}
		\caption{Sequential traffic}\label{lookup-throughput-sequential}
	\end{subfigure}%
	~
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{lookup-throughput-random}
		\caption{Random traffic (not a realistic traffic)}\label{lookup-throughput-random}
	\end{subfigure}%
	
	\caption{Lookup throughputs in different FIBs for different traffics}\label{lookup-performance}
\end{figure*}

\subsection{Memory Consumption} \label{memoryconsumption}
Figure \ref{memorycomp} shows the memory consumption of Poptrie and CP-Trie. It shows that CP-Trie consumes more memory than Poptrie. This is because CP-Trie stores cumulative PopCount along with population counting bitmap. Again, as CP-Trie uses $8$-bit stride, it may push a node further than Poptrie. However, this is not always the case. For instance, a prefix with length $48$ will be pushed to level $54$ in Poptrie, however that node will remain in level $48$ in CP-Trie. This is how, CP-Trie may need fewer level pushing than Poptrie for many prefixes. Our exprimental results show that CP-Trie consumes around $1.36-1.47 \times$ more memory than Poptrie.


\begin{comment}
 
\begin{figure}[!t]
\centering
\includegraphics[width=9cm]{memory-read}
\caption{The number of bytes read by FIB lookup}\label{mem-read}
\end{figure} 
 
\subsection{Memory Read Operation} 
The dynamic power consumption of a chip depends on the number of bytes read from the memory. This is why, it is important to measure the number of bytes read from memory. The number of bytes read by a FIB lookup algorithm depends on the length of the matched prefix. Figure \ref{mem-read} shows the number of bytes read for different prefix lengths. It shows that SAIL requires small amount of data to be read from memory. SAIL reads one array element ($4$ bytes) in each level except for the last level.\footnote{Here we have implemented chunk ID as a $32$-bit variable to accommodate future FIB expansion  whereas in the original implementation, it was implemented as a 16-bit variable.} In the last level, it reads one element from two arrays ($4 + 1$ bytes). On the other hand, CP-Trie needs to read $12$ bytes in each level except for the last level, because each element of $C$ array is $12$ bytes. In the last level, it reads $12 + 12 + 1$ bytes (one $C$ element, one $B$ element and one $Leaf$ element). Poptrie, on the other hand, needs to read $24$ bytes in each level. Poptrie also needs to visit more levels than SAIL and CP-Trie. This is why, Poptrie needs to read more data from memory than SAIL and CP-Trie.

\end{comment}

\subsection{Traffics for FIB Lookup}
We use four traffic patterns in this experiment: prefix, repeated, random and sequential traffic. 

\textbf{Prefix traffic: } Our prefix traffic consists of the prefixes in our FIBs. Prefix traffic ensures that the lookups are spread across a FIB. 

\textbf{Repeated traffic: } Our repeated traffic consists of $2^{24}$ randomly selected prefixes from the FIBs (with possible duplicates) and adding random bits at the "don't care" fields of the prefixes. Each IP in repeated traffic is looked up $10$ times repeatedly. Repeated traffic is analogous to a router handling small number of flows. Repeated traffic is prevalent in real world Internet trace \cite{wide-mawi}. As we produce the IPs within the range of the prefixes in the FIBs, our repeated traffic is analogous to the real Internet traces. In this paper, we do not use actual Internet trace \cite{wide-mawi}. This is  because the real Internet traces were not taken in the same backbone router as the FIBs. Thus, they are not within the ranges of prefixes in FIB. 

\textbf{Sequential traffic: } Our sequential traffic consists of $2^{8}$ sequentially increasing IPv6 addresses. The start address of the sequential traffic is selected such that all the IPs in sequential traffic requires matching up to the last level of the FIB. We use sequential traffic to measure the worst lookup throughput for a FIB.  

\textbf{Random traffic: } Our random traffic consists of $2^{24}$ random IPv6 addresses within 2000::/4. All the prefixes in our routing table data set also fall in this range. This is why, we choose the range. Note that, random traffic contains IP addresses that are not within the range of the prefixes. Thus, they may not find a match. This is why, random traffic is not a realistic traffic pattern. 

 



\begin{comment}

Finally, we use $15$ minutes real Internet trace \cite{wide-mawi}, captured on Aug 24, 2019 to generate \textbf{real} traffic. Here, we excluded the ICMP packets. We then extracted the destination IP addresses. We use the IPs as our \textbf{real} traffic. The IPs are within the ranges of the prefixes in our FIBs. Our \textbf{real} traffic contains $6,071,549$ IP addresses.

\end{comment}

 

\begin{comment}

\begin{figure*}[!t]
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{matched-prefix-len-cptrie}
		\caption{In CP-Trie and SAIL}\label{matched-prefix-len-cptrie}
	\end{subfigure}%
	~ 	
	\begin{subfigure}[t]{0.5\textwidth}
		\centering
		\includegraphics[width=9cm]{matched-prefix-len-poptrie}
		\caption{In Poptrie}\label{matched-prefix-len-poptrie}
	\end{subfigure}%
	
	\caption {Average matched prefix length for each traffic. Note that, SAIL and CP-Trie push the leaves to the same level. So, their average matched prefix length will be the same. Again, average matched prefix length of prefix and repeated traffic is also same.  }\label{matched-prefix-len}
\end{figure*}

\end{comment}

\subsection{Lookup Performance in Software}
Figure \ref{lookup-performance} shows the lookup performance in different FIBs for different traffics. We load each traffic in an array in advance and issue lookup query one by one in sequence. We measure the lookup performance in million lookups per second (Mlps). All the lookup throughputs in this paper are measured on a single CPU core. 

Figure \ref{lookup-throughput-prefix} and \ref{lookup-throughput-repeated} show that CP-Trie achieves higher throughput (by around $+3$ Mpls) than Poptrie for prefix and repeated traffic. This is because, CP-Trie needs to visit fewer level than Poptrie. Figure \ref{lookup-throughput-sequential} shows that CP-Trie outperforms Poptrie by upto $1.43 \times$ for sequential traffic. Note that, the lookup throughputs for sequential traffic vary significantly for different FIBs. The reason for this as following. We selected sequential traffic such that the matches are found in the last level. As the longest prefix in $fib3$, $fib4$, $fib8$ are $128$ bit long (Table \ref{fibdataset}), both Poptrie and CP-Trie needs to lookup up to the very last level which results in low throughput. On the other hand, the longest prefix in $fib0$, $fib1$, $fib6$ are $48$ bit long (Table \ref{fibdataset}), thus CP-Trie and Poptrie need to lookup up to level $48$ and $54$ respectively which result in higher throughput than the other FIBs. Again, the longest prefixes in $fib2$, $fib5$, $fib7$ are $64$ bit long (Table \ref{fibdataset}), thus they results in higher throughput that $fib3$, $fib4$, $fib8$, but lower throughput than $fib0$, $fib1$, $fib6$. Thus, \ref{lookup-throughput-sequential} shows how lookup throughput can vary based the length of the prefixes in the FIB. Finally, Figure \ref{lookup-throughput-random} shows that both CP-Trie and Poptrie achieves significantly higher throughput for random traffic. As random traffic contains many IP addresses that are not within the ranges of the prefixes (hence, not realistic), they only require looking up very few levels in the trie. As Poptrie uses direct match for the first $16$ bits, it can detect the unmatch very quickly. CP-Trie does not use such direct match which results in low throughput compared to Poptrie. In conclusion, the experiment shows that CP-Trie achieves very high throughput for realistic traffic patterns (such as prefix, repeated and sequential traffic). 

\begin{comment}

\subsection{Lookup Performance in Software}
Figure \ref{lookup-performance} shows the lookup performance in different FIBs for different traffics. We load each traffic in an array in advance and issue lookup query one by one in sequence. We measure the lookup performance in million lookups per second (Mlps). All the lookup throughputs in this paper are measured on a single CPU core. 

The Figure \ref{lookup-performance} shows that SAIL outperforms both CP-Trie and Poptrie to a great extent for all the traffics. This is because it needs to perform fewer operations at each level. It also needs fewer steps than Poptrie. SAIL stores data in arrays which is very cache friendly. As a result, SAIL outperforms both Poptrie and CP-Trie eventhough its memory consumption is significantly higher compared to CP-Trie and Poptrie. 

Figure \ref{lookup-throughput-prefix},  \ref{lookup-throughput-repeated} and  \ref{lookup-throughput-decreasing} show that CP-Trie outperforms Poptrie for \textbf{prefix}, \textbf{repeated} and \textbf{decreasing} traffic. CP-Trie needs to visit fewer levels than Poptrie. This results in higher throughput. On the contrary, Figure \ref{lookup-throughput-real} and \ref{lookup-throughput-random} show that Poptrie performs better than CP-Trie for \textbf{real} and \textbf{random} traffic. To investigate this behavior, we measure the average matched prefix lengths for each traffic in Figure \ref{matched-prefix-len}. The figure shows that the average matched prefix length for \textbf{real} and \textbf{random} traffic is only $16$ (for both CP-Trie and Poptrie). In other words, for \textbf{real} and \textbf{random} traffic, most of the longest prefix match was found around level $16$. Poptrie uses direct indexing for the prefixes with length $16$ or smaller. Thus, if the matched prefix length is less than or equal to $16$, Poptrie can find the longest match directly with just one memory access. This is why, Poptrie performs much better for those traffics. We did not use direct indexing in CP-Trie (direct indexing increases the memory consumption slightly). As a result, CP-Trie performs poorly compared to Poptrie when the average matched prefix length is $16$. It is however possible to introduce direct indexing in CP-Trie with trivial change. The Figure \ref{matched-prefix-len} shows that the average matched prefix length for \textbf{prefix}, \textbf{repeated} and \textbf{decreasing} traffic is $43-112$ (for both CP-Trie and Poptrie). CP-Trie outperforms Poptrie for those traffics.

Again, Figure \ref{lookup-throughput-sequential} shows mixed outcome for \textbf{sequential} traffic. Here, CP-Trie performs better than Poptrie in \textit{fib2}, \textit{fib3} and \textit{fib4} which is normal. However, CP-Trie performs poorly compared to Poptrie in \textit{fib0}, \textit{fib1}, \textit{fib5} and \textit{fib6}. This is because, in \textit{fib0}, \textit{fib1}, \textit{fib5} and \textit{fib6}, the average matched prefix length in Poptrie is smaller than that of CP-Trie (Figure \ref{matched-prefix-len}).


Note that, the actual lookup throughput vary dramatically based on traffic. For instance, SAIL achieves $170-320$ Mlps throughput for \textbf{repeated}, \textbf{sequential}, \textbf{decreasing}, \textbf{random} and \textbf{real} traffic. However, its lookup throughput degrades to just around $55$ Mlps for \textbf{prefix} traffic because \textbf{prefix} traffic does have the regularity as the other traffics. 

The lookup throughput of  CP-Trie and Poptrie also vary dramatically based on traffic. For instance, both CP-Trie and Poptrie achieves more than $100$ Mlps for real traffic. However, they both achieves less than $12$ Mlps for \textit{fib2} and \textit{fib4} of \textbf{decreasing} traffic (Figure \ref{lookup-throughput-decreasing}), because the average matched prefix length in those FIBs are within $107-112$ (Figure \ref{matched-prefix-len}). Thus, both Poptrie and CP-Trie in software performs very poorly when matched prefix length is very high. 


\end{comment}

\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{update}
	\caption{Average insertion time per prefix (smaller is better)}\label{update}
\end{figure}

\subsection{Update Performance in Software}
In order to evaluate the update performance, we measure the insertion time of the all the routes in a routing table. Figure \ref{update} shows the average insertion time per prefix for each routing table. The figure shows that CP-Trie requires slightly more time compared to Poptrie for insertion. The results also show that the update performance of CP-Trie and Poptrie are practically acceptable.
  
\begin{comment} 
 
\subsection{Lookup performance in ASIC}
We measure the performance in ASIC based on timing, area and power consumption.

\textbf{Timing characteristics:} Our experimental results from OpenROAD show that CP-Trie and Poptrie can achieve $454$ MHz and $400$ MHz clock frequency respectively (i.e. results positive slack for both shortest and longest path in static timing analysis \cite{kahng2011vlsi}). Since our Verilog code does not use pipelining, the frequencies do not correspond to the lookup throughput directly. However, the results indicate that CP-Trie perform $1.135 \times$ faster lookup compared to Poptrie.  



\begin {table}[H]
\caption {Area estimates in ASIC ($mm^2$)} \label{area} 
\begin{center}
	\begin{tabular}{ | m{2cm}| m{1.5cm}| m{1.5cm} |}
		\hline  & Poptrie & CP-Trie\\
		\hline Logic Area & $0.687995$ & $0.687995$ \\
		\hline SRAM Area & $17.88336$ & $22.3542$\\
		\hline Total Area & $18.571355$  & $23.042195$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\textbf{Area:} Our experimental results from OpenROAD show that CP-Trie and Poptrie require the same amount ($0.687995$ $mm^2$) of area for logic. However, the area of the SRAM modules needed by the algorithms vary significantly. CP-Trie and Poptrie consume up to $4.7$ MB and $3.1$ MB SRAM respectively. Thus, CP-Trie and Poptrie will need $5$ and $4$ SRAM modules respectively (each SRAM module is $1$ MB). Our experimental results based on CACTI-P \cite{li2011cacti} show that $1$ MB SRAM module takes $4.47084 \ mm^2$ at $40$ nm technology. Thus, the total area of SRAM for CP-Trie and Poptrie would be $22.3542 \ mm^2$ and $17.88336 \ mm^2$ respectively. Table \ref{area} shows the total area for each algorithm. The table shows that SRAM requires significantly more area than the logic. It also shows that Poptrie requires smaller area compared to CP-Trie.



  \begin {table*}[t]
\caption {Power consumption in ASIC (mW)} \label{powerconsumption_openroad} 
\begin{center}
	\begin{tabular}{c|c|c|c|c|c|c|}
		\hline
		\multicolumn{1}{|c|}{Logic clock speed} & $400$ MHz & $454$ MHz &\multicolumn{2}{|c|}{$400$ MHz} & \multicolumn{2}{|c|}{$1$ GHz}\\
		\hline
		\multicolumn{1}{|c|}{Algorithm} & Poptrie & CP-Trie & Poptrie & CP-Trie & Poptrie & CP-Trie\\
		\hline 
		\multicolumn{1}{|c|}{Logic Internal Power} & $29.5$ & $23.3$ & $29.5$ & $20.5$ & $73.9$ & $51.5$\\
		\hline 
		\multicolumn{1}{|c|}{Logic Switching Power} & $15.8$  & $13.2$ & $15.8$  & $11.6$ & $39.4$  & $29.1$\\
		\hline
		\multicolumn{1}{|c|}{Logic Leakage Power} & $2.66$ & $2.23$ & $2.66$ & $2.23$ & $2.66$ & $2.24$\\
		\hline
		\multicolumn{1}{|c|}{Logic Power} & $48.00$  & $38.8$ & $48.00$  & $34.4$ & $116.00$  & $82.8$\\
		\hline
		\multicolumn{1}{|c|}{SRAM Power} & $493.576$  & $616.97$ & $493.576$  & $616.97$ & $493.576$  & $616.97$\\
		\hline
		\multicolumn{1}{|c|}{Total Power}& $541.576$  & $655.77$ & $541.576$  & $651.37$ & $609.576$  & $699.77$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table*}

\textbf{Power consumption:} Table \ref{powerconsumption_openroad} shows the power consumption of ASIC. Here, the power consumption of logic is measured by OpenROAD and the power consumption of SRAM is measured by CACTI-P. Here, we measure the power consumption of logic for different frequencies. Note that,  although the algorithms do not pass the timing constraint at $1$ GHz, the power consumption at $1$  GHz is still valid. Table \ref{powerconsumption_openroad} shows that the logic of SAIL consumes very small power compared to that of CP-Trie and Poptrie. Again, the logic of Poptrie consumes more power than that of CP-Trie because it needs to visit more levels than CP-Trie. However, note that SAIL, Poptrie and CP-Trie needs $29$, $4$ and $5$ SRAM modules respectively. Thus, their SRAM power consumption would be $3578.426$ mW, $493.576$ mW and $616.97$ mW respectively (each SRAM module consumes $123.394$ mW according to CACTI-P). Table \ref{powerconsumption_openroad} shows the total power consumption of the algorithms. It shows that the total power consumption of SAIL is significantly higher than that of Poptrie and CP-Trie due to its large memory requirement. Again, the power consumption  of CP-Trie is higher than that Poptrie. Also, note that the power consumption increases with the increase of clock frequency. 

\end{comment}


\begin{comment}

\subsection{Performance estimates in a pipelined ASIC}
In order to evaluate SAIL, Poptrie and CP-Trie for a pipelined ASIC, we simulate them within Aladdin. A FIB lookup algorithm in an ASIC with pipelining can process incoming packets at a line rate. As we select $1$ GHz frequency, the simulated ASIC should be able to process $1$ packet in every $1$ns (thus $1$ billion packets per second). As the lookup throughput is constant, we compare the area, power consumption, latency of the lookup algorithms.

\begin {table}[H]
\caption {Area estimates in ASIC ($mm^2$)} \label{area} 
\begin{center}
	\begin{tabular}{ | m{2cm}| m{1.5cm}  | m{1.5cm}| m{1.5cm} |}
		\hline  & SAIL\_L & Poptrie & CP-Trie\\
		\hline Logic Area & $0.00879774$ & $0.0156588$ & $0.0155502$ \\
		\hline Memory Area & $89.22$ & $6.81073$ & $7.81316$\\
		\hline Total Area & $89.2288$ & $6.82639$  & $7.82871$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\textbf{Area:} Table \ref{area} shows the chip area needed for SAIL, Poptrie and CP-Trie. Here the area is divided into memory and logic. It shows that SAIL requires almost $11 \times$ area compared to Poptrie and CP-Trie. It is also noteworthy that memory contributes $94-99.5\%$ of the total chip area. This is why, memory consumption has a greater impact on the overall performance compared to the logic operations.

\begin {table}[H]
\caption {Power estimates in ASIC (mW)} \label{powerconsumption} 
\begin{center}
	\begin{tabular}{ | m{3.8cm}| m{1cm} | m{1cm}  | m{1.4cm}|}
		\hline  & SAIL\_L & Poptrie & CP-Trie\\
		\hline Avg. Logic Dynamic Power& $4.2375$ & $8.19812$ & $6.14745$\\
		\hline Avg. Logic Leakage Power& $1.53639$ & $0.184721$ & $0.184778$\\
		\hline Avg. Logic Power& $5.77389$ & $8.38284$  & $6.33222$\\
		\hline Avg. Memory Dynamic Power& $3.83403$ & $1.9186$  & $1.668$\\
		\hline Avg. Memory Leakage Power& $1390.16$ & $103.299$  & $118.467$\\
		\hline Avg. Memory Power& $1394$ & $105.217$  & $120.135$\\
		\hline Avg. Power& $1399.77$ & $113.6$ & $126.468$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin {table}[H]
\caption {Latency estimates in ASIC} \label{latency} 
\begin{center}
\begin{tabular}{ | m{3.5cm}| m{1cm} | m{1cm} | m{1.4cm} |}
\hline  & SAIL\_L & Poptrie & CP-Trie\\
\hline \# of Cycles (pipeline stages) & $107$ & $207$  & $157$\\
\hline Delay & $107$ ns & $207$ ns & $157$ ns\\
\hline 
\end{tabular} 	
\end{center}
\end {table}

\textbf{Power consumption:} Table \ref{powerconsumption} shows the power consumption for SAIL, Poptrie and CP-Trie. Here the power consumption is broken into leakage and dynamic power for both memory and logic. It shows that SAIL consumes almost $11 \times$ power compared to Poptrie and CP-Trie. It is also noteworthy that memory contributes $88-99.5\%$ of the total power consumption. This is why, memory has a greater impact on the overall power consumption compared to the logic operations. It is also noteworthy that $97-99.5\%$ of the memory power is  leakage power. This indicates that the memory consumption has a greater impact on the power consumption than the amount of memory read during FIB lookup. Note that these characteristics can vary for different underlying technology. For instance, here we use scratch-pad memory (SRAM) for power consumption. It has been reported that high-speed routers can use RLDRAM and FCRAM on the chip besides SRAM \cite{eatherton2004tree}. Such DRAMs will have a different power characteristics than that of an SRAM. However the power consumption for such platforms are out of the scope of this paper.  

\textbf{Latency}: Table \ref{latency} shows the latency for different algorithms. It shows that, although all of the FIB lookup algorithms can achieve the same line rate, the processing latency is the smallest for SAIL, followed by CP-Trie and Poptrie. Poptrie has the highest latency. Note that although all the latencies are in nanoseconds, they can be a critical factor in certain types of networks such as financial service networks.

\end{comment}
 
\begin{comment}

\subsection{Lookup performance in FPGA}
We simulate SAIL, Poptrie and CP-Trie lookup algorithms for Xilinx Zynq-$7000$ series xc7z020-1clg484 FPGA. Our experimental results show that the clock frequencies of SAIL, CP-Trie and Poptrie are $244$ MHz, $231$ MHz and $197$ MHz respectively. Since our Verilog code does not use pipelining, the frequencies do not correspond to the lookup throughput directly. However, they still indicate that SAIL and CP-Trie perform $1.23 \times$ and $1.17 \times$ faster lookup respectively compared to Poptrie.

\end{comment}

\section{Discussion}\label{discussion}
CP-Trie improves the routing table lookup by using longer stride than Poptrie. CP-Trie can also be useful for Named Data Networking (NDN) lookup. NDN uses longest prefix match on the names \cite{zhang2014named, song2015scalable}. The names in NDN can be significantly longer than an IPv6 prefix. As CP-Trie uses longer stride, it would be a more practical solution for NDN prefix match compared to Poptrie. However, NDN prefixes are also variable length. Thus, CP-Trie needs to be modified for NDN lookup. A research should be done on NDN prefix match based on CP-Trie.

\section{Conclusion}\label{conclusion}
This paper presents a cumulative PopCount based routing table lookup algorithm named CP-Trie. CP-Trie is an extension of Poptrie. CP-Trie requires fewer steps than Poptrie which results in higher lookup performance. It also improves the power consumption in ASIC by reducing the number of steps and requiring fewer SRAM blocks. We implemented CP-Trie and Poptrie in software and pipelined ASIC. Our experimental results show that CP-Trie achieves higher throughput in software and cosumes less area and power in ASIC.

\begin{comment}

Currently, our ASIC implementation does not use pipelining. Implementation of the FIB lookup algorithms in a pipelined ASIC will be needed in the future in order to process the incoming packets at line rate.

Currently, we are using Nangate $45$nm standard-cell library which is developed based on the FreePDK45 \cite{FreePDK}. FreePDK45 is an open Process Development Kit (PDK) mainly developed by universities. It was developed based on publicly available data of commercial 45nm processes. It is not a real PDK from a foundry. Thus, Nangate $45$nm standard-cell library based ASIC is not manufacturable by a foundry. Gaining access to a commercial PDK is a difficult process. It requires negotiating with the foundry and signing multiple non-disclosure agreements. This is why, we use Nangate $45$nm standard-cell library. However, research should be conducted on synthesizing the FIB lookup ASIC with foundry provided cell libraries. 

We also need to implement a packet parser, packet buffer, queuing, monitoring, protocol processing, etc in a router dataplane ASIC \cite{bosshart2013forwarding}. The dataplane ASIC is connected to the port modules via Chip-to-Chip (C2C) interface \cite{lara2010industry}. We need to implement appropriate C2C interface protocol (e.g. 400GAUI-8, 200GAUI-8, 100GAUI-8, etc) in the ASIC. A tape out of the chip will also be necessary. Finally, the chip should be tested on an open switching/routing platforms such as Facebook Wedge \cite{choi2018fboss}.

\end{comment}

\bibliographystyle{IEEEtran}
\bibliography{cp-trie-hpsr}

\begin{comment}

\appendix

\section{Software Implementation}
The software implementation will be found in the "CP-Trie" folder of the artifact.\footnote{https://www.dropbox.com/sh/ae6zmoxds36mzpn/AAAhXHGcxjFD-Ao6DL9lWQ0Na?dl=0} The folder contains the implementation of CP-Trie, SAIL and Poptrie. We have implemented all these algorithms in a single program. The folder also contains FIB dataset and a 'README.md' file which contains the instructions to run the program. To reproduce the results of this paper, one needs to download the folder on a Linux machine. Although we conducted the experiment on an Ubuntu Gnome $16.04$, it should work on any Linux platform. Then one can compile the program with a simple 'make' command in the terminal. This will compile the program and create an executable file named 'main\_ipv6'.  Now one can run the program on the terminal as './main\_ipv6'. Then then program will test FIB update and FIB insert for the data set and write the results in a text file named 'summery.data'. 

\section{ASIC Implementation}
The ASIC implementation will be found in the "aladdin" folder of the artifact. To reproduce the results of this paper, one needs to download the "aladdin" folder on a Linux machine and follow the instruction in the 'README.md'. The implementation of CP-Trie, SAIL and Poptrie will be found in "fib\_lookup" folder inside "aladdin". Note that the 'README.md' explains how to run the 'triad' program inside SHOC folder. One needs to follow the similar procedure to run CP-Trie, SAIL and Poptrie programs inside "fib\_lookup" folder.

\end{comment}

\end{document}
